import assert from 'assert';
import utils from '../src/utils.js';

const bits = 32;
const msg = "I'm 大戴禮記, and my dad's ابوابو عبد الله🤣😜";

describe('Utils', function () {
    describe('decode()', function () {
        const nums = utils.decode(msg, bits, 'utf8');
        const encodedNums = utils.encode(nums, bits, 'base64', true);
        const decodedNums = utils.decode(encodedNums, bits, 'base64');

        it('should get the right numbers', function () {
            for (let i = 0; i < decodedNums.length; i++) {
                assert.equal(nums[i].toString(16), decodedNums[i].toString(16))
            }
        });

        describe('encode()', function () {
            it('should get the message', function () {
                const msgDecode = utils.encode(decodedNums, bits, 'utf8');
                assert.equal(msg, msgDecode)
            });
        });
    });
});
